module StructuredSearch

  # A token generated by the lexer
  class Token

    #+token+:: The token's type
    #+lexeme+:: The matched characters that make up the token
    #+column+:: Column this token was located
    #+line+:: Line this token was located
    attr_accessor :token, :lexeme, :column, :line

    #:nodoc:
    def initialize(tok = {})
      #send val to key setter
      tok.each do |k, v|
        send "#{k}=", v
      end
    end

    # Returns a string representation of the token
    def to_s
      "#{@token}: '#{@lexeme}' (Line #{@line}, Column #{@column})"
    end
  end

end

